/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : skill_wb.c
Last edit : 10/20/92
Created   :
Version   : 1.5

History   :

Does      :
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <curses.h>

#include <paths.h>
#include <ruutu.h>
#include <mform.h>
#include <limits.h>

#include "profe_mai.h"
#include "chosen.h"
#include "ski_cost.h"

#ifdef strchr
#undef strchr
#endif

static char 		**names=NULL;
static int  		*stats=NULL;
static int  		*group=NULL;
static int  		lkm=0;
static int  		*cost=NULL;
static int  		*lvl=NULL;
static struct profe_mai profe;
static OS_CHOSEN 	ch_lst=NULL;

extern char 		*get_word(FILE *);
extern void 		put_ski_cost(struct ski_cost*);
extern struct ski_cost 	*get_ski_cost(struct ski_cost*);
extern char		*mstrtok(char *, char *);

void 			add_one(int,int);
void			taken(int);
void			load_skills(char *);
void			save_skills(char *);

int get_skills(void)
{
  FILE 	*src=NULL;
  char 	*fname=NULL;
  int 	i=0;
  char 	*a=NULL;
  char 	*b=NULL;
  int  	c = 0;

  src = fopen(SKILLS,"r");
  if(!src) {
    perror("fopen/skill_wb.c");
    exit(0);
  }
  lkm = atoi(get_word(src));
  
  names = (char **)calloc(lkm+1, sizeof(char *));
  if(!names) {
    perror("skill_wb.c/calloc()");
    exit(0);
  }
  
  stats = (int *)calloc(lkm+1, sizeof(int)*3);
  if(!stats) {
    perror("skill_wb.c/calloc()");
    exit(0);
  };	
  
  group = (int *)calloc(lkm+1, sizeof(int));
  if(!group) {
    perror("skill_wb.c/calloc()");
    exit(0);
  };
  
  cost  = (int *)calloc(lkm+1, sizeof(int)*3);
  if(!cost) {
    perror("skill_wb.c/calloc()");
    exit(0);
  };
  
  lvl = (int *)calloc(lkm+1, sizeof(int));
  if(!lvl) {
    perror("skill_wb.c/calloc()");
    exit(0);
  };
  
  for(i=0;i<lkm;i++) {
    a = get_word(src);
    b = strdup(a);
    if(!b) {
      perror("strdup/skill_wb.c");
      exit(0);
    };
    names[i]=b;
    a = get_word(src);
    stats[i*3] = atoi(a);
    a = get_word(src);
    stats[i*3+1] = atoi(a);
    a = get_word(src);
    stats[i*3+2] = atoi(a);
    a = get_word(src);
    group[i] = atoi(a);
    lvl[i] = -1;
    cost[i*3] = -1;
    cost[i*3+1] = -1;
    cost[i*3+2] = -1;
    move(21,1);
    printw("%-30s %3i %3i %3i %3i  (%3i / %3i)",
	    names[i], stats[i*3],stats[i*3+1],stats[i*3+2],group[i], i+1,lkm);
    refresh();
  }
  fclose(src);
  return;
}     

int put_skills(void)
{
  FILE 	*dst=NULL;
  char 	*fname=NULL;
  int 	i=0;
  char 	*a=NULL;
  char 	*b=NULL;
  int  	c = 0;
  char  puskuri[50];
  int   j=0;
  int   l=0;

  dst = fopen(SKILLS,"w");
  if(!dst) {
    perror("fopen/skill_wb.c");
    exit(0);
  }
  sprintf(puskuri,"%3i",lkm);
  fprintf(dst,"%s\n",puskuri);
  
  for(i=0;i<lkm;i++) {
    l = strlen(names[i]);
    for(j=0;j<l;j++)
      if(names[i][j]==' ')
	names[i][j] = '_';	    		
    fprintf(dst,"%-24s",names[i]);
    sprintf(puskuri,"%3i",stats[i*3]);
    fprintf(dst," %5s ",puskuri);
    sprintf(puskuri,"%3i",stats[i*3+1]);
    fprintf(dst," %5s ",puskuri);
    sprintf(puskuri,"%3i",stats[i*3+2]);
    fprintf(dst," %5s ",puskuri);
    sprintf(puskuri,"%3i",group[i]);
    fprintf(dst," %5s \n",puskuri);

    move(23,1);
    printw("%-30s (%3i / %3i)",
	    names[i], i+1,lkm);
    refresh();
  }
  fclose(dst);
  return;
}     

void load_skills(char *arg)
{
  char 	*directory=NULL;
  int 	len = 0;
  char 	*name=NULL;
  char 	*primes=NULL;
  int	p=0;
  FILE 	*src;
  int 	i=0;
  char 	*a=NULL;

  directory = mstrtok(arg," \t\n\0");
  if(!directory) {
    perror("skill_wb/strtok");
    exit(0);
  }

  len = 2 * strlen(directory) + strlen(SAVE) + 14 + 5;
  name = malloc(len);
  if(!name) {
    perror("malloc");
    exit(0);
  }
  sprintf(name,"%s/%s/%s.skills",SAVE,directory,directory);
  ch_lst = load_skill_lst(name);
}

void save_skills(char *arg)
{
  char 	*directory=NULL;
  int 	len = 0;
  char 	*name=NULL;
  char 	*primes=NULL;
  int	p=0;
  FILE 	*src;
  int 	i=0;
  char 	*a=NULL;

  directory = strtok(arg," \t\n\0");
  if(!directory) {
    perror("skill_wb/strtok");
    exit(0);
  }

  len = 2 * strlen(directory) + strlen(SAVE) + 14 + 5;
  name = malloc(len);
  if(!name) {
    perror("malloc");
    exit(0);
  }
  sprintf(name,"%s/%s/%s.skills",SAVE,directory,directory);
  save_skill_lst(name,ch_lst);
}

void fetch_costs(char *arg)
{
  char 	*directory=NULL;
  int 	len = 0;
  char 	*name=NULL;
  char 	*primes=NULL;
  int	p=0;
  FILE 	*src;
  int 	i=0;
  char 	*a=NULL;

  directory = mstrtok(arg," \t\n\0");
  if(!directory) {
    perror("skill_wb/strtok");
    exit(0);
  }

  len = 2 * strlen(directory) + strlen(SAVE) + 14 + 5;
  name = malloc(len);
  if(!name) {
    perror("malloc");
    exit(0);
  }
  sprintf(name,"%s/%s/%s.profe",SAVE,directory,directory);
  src  = fopen(name,"r");
  if(!src) {
     perror("skill_wb.c/fopen");
     exit(0);
  };
  fread(&profe,sizeof(struct profe_mai),1,src);
  
  fclose(src);
  free(name);

  name = (char *)malloc(strlen(COSTS)+strlen(profe.profession)+2);
  sprintf(name,"%s/%s",COSTS,profe.profession);
  src = fopen(name,"r");
  if(!src) {
    move(21,1);
    printw("Bad luck pal! No cost data! Press a key. %36c",' ');
    refresh();	
    getch();	
    return;
  };
  for(i=0;i<lkm;i++) {
    a = get_word(src);		
    a = get_word(src);
    cost[i*3] = atoi(a);
    a = get_word(src);
    cost[i*3+1] = atoi(a);
    a = get_word(src);
    cost[i*3+2] = atoi(a);
    move(21,1);
    printw("%-20s (%3i/%3i)                             ",names[i],i+1,lkm);
    refresh();
  }
  fclose(src);
}


void put_costs(char *arg)
{
  char 	*directory=NULL;
  int 	len = 0;
  char 	*name=NULL;
  char 	*primes=NULL;
  int	p=0;
  FILE 	*dst;
  int 	i=0;
  int   j=0;
  int   l=0;
  char  puskuri[50];

  directory = mstrtok(arg," \t\n\0");
  if(!directory) {
    perror("skill_wb/mstrtok");
    exit(0);
  }

  name = (char *)malloc(strlen(COSTS)+strlen(profe.profession)+2);
  sprintf(name,"%s/%s",COSTS,profe.profession);
  dst = fopen(name,"w");
  if(!dst) {
    move(23,1);
    printw("File write error! No cost data saved! Press a key!");
    refresh();	
    getch();	
    return;
  };
  move(23,1);
  clrtoeol();
  refresh();
  for(i=0;i<lkm;i++) {
    l = strlen(names[i]);
    for(j=0;j<l;j++)
      if(names[i][j]==' ')
	names[i][j] = '_';	    		
    fprintf(dst,"%-24s",names[i]);
    sprintf(puskuri,"%3i",cost[i*3]);
    fprintf(dst," %5s ",puskuri);
    sprintf(puskuri,"%3i",cost[i*3+1]);
    fprintf(dst," %5s ",puskuri);
    sprintf(puskuri,"%3i",cost[i*3+2]);
    fprintf(dst," %5s\n",puskuri);

    move(23,1);
    printw("%-24s (%i/%i)",names[i],i+1,lkm);
    refresh();
  }
  fclose(dst);
}

void choose(char *arg)
{
  int m=0;
  int a=0;
  int b=0;
  int c=0;
  int sivu=0;
  int ok = 1;
  int nro=0;
  char costi[30]="";
  int i=0;
  char keys[22]="0123456789acdghijklm";
  int j=0;
  int mode=0;

  clear();
  refresh();
  while(ok) {
    move(0,0);
    attron(A_UNDERLINE);
    printw("Number  Skill                             Cost         Level  Chosen");
    attroff(A_UNDERLINE);
    for(i=0;i< 20;i++) {
      move(i+1,1);
      nro = i + 20 * sivu;
      if(nro >= lkm) {
        printw("                                                                    ");
	continue;
      }
      a = cost[nro*3];
      b = cost[nro*3+1];
      c = cost[nro*3+2];
      if(a == -1) 
        sprintf(costi,"??????????");
      else {
	sprintf(costi,"%2i",a);
	if(b != -1)
	  if(!b)
	    sprintf(costi,"%2i/*",a);
	  else 
	    sprintf(costi,"%2i/%2i",a,b);
	    if(c != -1)
	      if(!c)
		sprintf(costi,"%2i/%2i/*",a,b);
	      else 
		sprintf(costi,"%2i/%2i/%2i",a,b,c);
      }	 
      if(group[nro] != -1 && lvl[nro] == -1) {
	switch(group[nro]) {
	  case '0':
	    lvl[nro] = profe.acd;
	    break;
	  case '1':    		         
	    lvl[nro] = profe.arm;
	    break;
	  case '2':
	    lvl[nro] = profe.ath;
	    break;
	  case '3':
	    lvl[nro] = profe.bas;
	    break;
	  case '4':
	    lvl[nro] = profe.bod;
	    break;
	  case '5':
	    lvl[nro] = profe.con;
	    break;
	  case '6':
	    lvl[nro] = profe.dea;
	    break;
	  case '7':
	    lvl[nro] = profe.dir;
	    break;
	  case '8':
	    lvl[nro] = profe.gen;
	    break;
	  case '9':
	    lvl[nro] = profe.lin;
	    break;
	  case 'a':
	    lvl[nro] = profe.mag;
	    break;
	  case 'b':
	    lvl[nro] = profe.med;
	    break;
	  case 'c':
	    lvl[nro] = profe.out;
	    break;
	  case 'd':
	    lvl[nro] = profe.per;
	    break;
	  case 'e':
	    lvl[nro] = profe.soc;
	    break;
	  case 'f':
	    lvl[nro] = profe.sub;
	    break;
	}
      }
      printw("  %c    %-30s  %-10s      %-3i     %1i  ",
	      keys[i], names[nro],costi,lvl[nro],num_of_chosen(nro,ch_lst));
    }
    move(22,1);
    attron(A_BOLD);
    printw("0-m ");
    attroff(A_BOLD);
    printw("to choose,");
    printw(" One page ");
    attron(A_BOLD);
    printw("F");
    attroff(A_BOLD);
    printw("orward or ");
    attron(A_BOLD);
    printw("B");
    attroff(A_BOLD);
    printw("ackward, ");
    printw("E");
    attron(A_BOLD);
    printw("x");
    attroff(A_BOLD);
    printw("it, ");
    attron(A_BOLD);
    printw("E");
    attroff(A_BOLD);
    printw("dit, ");
    attron(A_BOLD);
    printw("U");
    attroff(A_BOLD);
    printw("nchoose");	
    refresh();
    m = getch();
    mode = 0;
    switch(m) {
      case 'f':
	if(nro < lkm)
	  sivu++;
	break;
      case 'b':
	if(sivu > 0)
	  sivu--;
	break;
      case 'x':
	put_skills();
	put_costs(arg);
	return;
      case 'u':
	move(22,0);
	clrtoeol();
	refresh();
	printw("Which one?");
	m = getch();
	for(j=0;j < 20; j++) 
	  if(m == keys[j]) 
	    if(j+20*sivu >= lkm)
	      break;
	    else 
	      ch_lst = remove_one(j+20*sivu, ch_lst);
	break;
      case 'y':
	scrollok(stdscr,TRUE);
	dump_list(ch_lst);
	scrollok(stdscr,FALSE);
	clear();
	refresh();
	break;	
      case 'e':
	move(22,0);
	clrtoeol();
	refresh();
	printw("Which one?");
	m = getch();
	mode =1;
      default:
	for(j=0;j < 20; j++) 
	  if(m == keys[j]) 
	    if(j+20*sivu >= lkm)
	      break;
	    else 
	      add_one(j+20*sivu,mode);
	break;
    }
  }
}

void add_one(int nro, int mode)
{
  int ok = 0;
  struct ski_cost sc;
  int i=0;
  char *a=NULL;
  char *b=NULL;

  sprintf(sc.profession,"%s",profe.profession);
  sprintf(sc.skill,"%s",names[nro]);
  sprintf(sc.cost,"??/??/??");
  
  if(group[nro] != -1)
    sc.group = group[nro];
  else
    sc.group = ' ';

  if(mode)
    lvl[nro] = -1; 

  while(!ok) {
    if((cost[nro*3] != -1) && (lvl[nro] != -1)) 
      ok = 1;
    else {
      clear();	
      put_ski_cost(&sc);
      get_ski_cost(&sc);
      a = strtok(sc.cost,"/\n\0");	
      if(!a)
	continue;
      cost[nro*3] = atoi(a);
      a = strtok(NULL,"/\n\0");
      if(a)
        if(a[0] == '*')
	  cost[nro*3+1] = 0;
	else {
	  cost[nro*3+1] = atoi(a);	
	  a = strtok(NULL,"/\n\0");
	  if(a)
	    if(a[0] == '*')
	      cost[nro*3+2] = 0;
	    else
	      cost[nro*3+2] = atoi(a);
	}
	if(cost[nro *3] >= -1 && cost[nro] < 26)
	  if(cost[nro *3+1] >= -1 && cost[nro+1] < 26)
  	    if(cost[nro *3+2] >= -1 && cost[nro+2] < 26)
	      ok = 1;
	if(!strchr("0123456789abcdef",sc.group)) {
	  ok = 0;
	}
	else {
  	  group[nro] = sc.group;
	}
       printw(" ");
       refresh();	
       clear();
       refresh();
    }
  }
  if(group[nro] != -1 && lvl[nro] == -1) {
    switch(group[nro]) {
      case '0':
        lvl[nro] = profe.acd;
        break;
      case '1':    		         
        lvl[nro] = profe.arm;
        break;
      case '2':
        lvl[nro] = profe.ath;
        break;
      case '3':
        lvl[nro] = profe.bas;
        break;
      case '4':
        lvl[nro] = profe.bod;
        break;
      case '5':
        lvl[nro] = profe.con;
        break;
      case '6':
        lvl[nro] = profe.dea;
        break;
      case '7':
        lvl[nro] = profe.dir;
        break;
      case '8':
        lvl[nro] = profe.gen;
        break;
      case '9':
        lvl[nro] = profe.lin;
        break;
      case 'a':
        lvl[nro] = profe.mag;
        break;
      case 'b':
        lvl[nro] = profe.med;
        break;
      case 'c':
        lvl[nro] = profe.out;
        break;
      case 'd':
        lvl[nro] = profe.per;
        break;
      case 'e':
        lvl[nro] = profe.soc;
        break;
      case 'f':
        lvl[nro] = profe.sub;
        break;
    }
  }
  if(!mode)
    taken(nro); 
}

void taken(int nro)
{
  OS_CHOSEN n;

  n = (OS_CHOSEN)calloc(1,sizeof(CHOSEN));
  if(!n) {
    perror("skill_wb.c/calloc");
    exit(0);
  }
  sprintf(n->skill,"%s",names[nro]);
  n->num = 1;
  n->nro = nro;
  n->costa = cost[nro *3];
  n->costb = cost[nro *3+1];
  n->costc = cost[nro *3+2];
  n->stata = stats[nro *3];
  n->statb = stats[nro *3+1];
  n->statc = stats[nro *3+2];
  n->ranks = 0;
  n->lvl   = lvl[nro];
  ch_lst = add_one_skill(n,ch_lst); 
}
           	       	
void do_skills(char *arg)
{
  get_skills();
  fetch_costs(arg);
  load_skills(arg);
  choose(arg); 
  save_skills(arg);
}

